<template>
  <q-page class="text-center">
    <div class="form">
      <q-input
        v-model="username"
        filled
        type="normal"
        label="username"
        :disable="true"
      />
      <q-input
        v-model="hire_date"
        filled
        type="normal"
        label="hire date"
        :disable="true"
      />
      <q-input
        v-model="position"
        filled
        type="normal"
        label="position"
        @keyup.enter="submit"
      />
      <q-select
        class="q-ml-sm"
        v-model="jobRank"
        :options="[1, 2, 3]"
        :disable="false"
        label="job rank"
        @keyup.enter="submit"
      />
      <q-select
        class="q-ml-sm"
        v-model="dep_code"
        :options="departments"
        :disable="false"
        label="Department"
        @keyup.enter="submit"
      />
      <q-checkbox
        class="float-left"
        v-model="isAdmin"
        label="Admin"
        toggle-order="ft"
        @toggle="getAdmin"
      />
    </div>
    <div>
      <q-btn
        class="q-ma-md"
        color="primary"
        text-color="white"
        label="Update User"
        @click="submit"
      />
    </div>
  </q-page>
</template>

<script>
import { api } from "boot/axios";

export default {
  data() {
    return {
      username: "",
      position: "",
      hire_date: "",
      position: "",
      jobRank: null,
      dep_code: "",
      isAdmin: false,

      departments: []
    };
  },
  methods: {
    getAdmin() {
      console.log(this.isAdmin);
    },

    getUser() {
      const url = window.location.pathname;
      const username = url.substring(url.lastIndexOf("/") + 1);

      console.log(username);

      const reqData = {
        username: username
      };

      api
        .post("/api/user/getUser", reqData)
        .then(res => {
          if (res.status == 200) {
            this.username = res.data.user.username;
            this.position = res.data.user.position;
            this.hire_date = res.data.user.hire_date;
            this.jobRank = res.data.user.jobRank;
            this.dep_code = res.data.user.dep_code;
            this.isAdmin = res.data.user.isAdmin;
          }
        })
        .catch(error => {
          this.$q.notify({
            color: "red-5",
            textColor: "white",
            icon: "warning",
            message: error.message
          });
        });
    },

    getDepartments() {
      api.post("/api/user/getDepartments").then(res => {
        // console.log(res.data);
        for (let i = 0; i < res.data.departments.length; i++)
          this.departments.unshift(res.data.departments[i].dep_code);
      });
    },
    submit() {
      // console.log(this.isAdmin);
      var reqData = {
        token: sessionStorage.token,
        username: this.username,
        isAdmin: this.isAdmin,
        dep_code: this.dep_code,
        hire_date: this.hire_date,
        position: this.position,
        jobRank: this.jobRank,
        hasEverLoggedIn: false
      };

      api
        .post("/api/user/update", reqData)
        .then(res => {
          if (res.status == 200) {
            this.$q.notify({
              color: "secondary",
              textColor: "white",
              icon: "check",
              message: "User updated!"
            });
            // setTimeout(2500);
            // this.$router.push("/admin");

            setTimeout(() => {
              this.$router.push("/admin");
            }, 2500);
          }
        })
        .catch(error => {
          this.$q.notify({
            color: "red-5",
            textColor: "white",
            icon: "warning",
            message: error.message
          });
        });
    }
  },
  mounted() {
    this.getDepartments();
    this.getUser();
    // console.log(".");
  }
};
</script>

<style>
.form {
  margin: auto;
  width: 50%;
  padding: 10px;
}
</style>
